// Datei NachfolgerFloat.c
/* ------------------------------------------------------------------------
Dieses Programm leistet folgendes:
------------------------------------------------------------------------ */
#include <stddef.h>  // Typen ptrdiff_t, size_t, wchar_t, Konstante NULL
#include <stdio.h>   // E/A in Bytestroeme, printf, sprintf, ...
#include <stdlib.h>  // atof, atoi, rand, malloc, calloc, free, exit,
                     // bsearch, qsort, abs, div, ...
#include <string.h>  // memcopy, memmove, strcpy, strcat, ...
#include <gmp.h>     // Gnu Multiple Precision Library
// ------------------------------------------------------------------------
// Der Name mit dem dieses Programm gestartet wurde (wird von der
// main-Funktion initialisiert):

char * progName;
// ------------------------------------------------------------------------
float liesFloat() {
   // Liest eine Zahl ein, wandelt sie in einen float-Wert um und
   // liefert diesen Wert. Als Eingabe sind alle Zeichenketten erlaubt,
   // die wie ein float-Literal in einem C-Programm aussehen.
   char   eingabe[100];
   float ergebnis = 0.0;
   printf("-----------------------------------------------------------\n");
   printf("Eine Zahl (q zum Beenden): ");
   scanf("%s", eingabe);
   if (eingabe[0] == 'q') {
      printf("%s beendet sich!\n", progName);
      exit(0);
   }
   sscanf(eingabe, "%f", &ergebnis); // %f fuer float (%lf ist fuer double)!

   return ergebnis;
} // liesFloat
// ------------------------------------------------------------------------
void gibAusGmpFloat(mpf_t flt) {
   // Gibt die GMP-float-Zahl flt in (einigermassen) lesbarer Form aus
   // (evtl. mit einem Lineal darunter).

   char     mantisse[100];
   mp_exp_t exponent;
   char *   txt = "Wahrer Wert:";

   // flt wird in einen String von Dezimalziffern (mantisse) und einen
   // Ganzzahlwert (exponent) umgewandelt:
   mpf_get_str(mantisse, &exponent, 10, 0, flt);
   // mantisse  In diesen Speicherbereich werden die Vorpunktstellen der
   //           Zahl flt geschrieben. Allerdings: Wenn flt den Wert 0.0
   //           hat, wird nicht der String "0", sondern ein leerer String
   //           nach mantisse geschrieben.
   // &exponent Zu dieser Adresse wird der Exponent von flt geschrieben
   // 10        Die Mantisse und der Exponent werden im 10-er-System
   //           (Dezimalsystem) dargestellt.
   // 0         Es sollen ALLE Nachpunktstellen von flt erzeugt werden
   //           (haetten wir statt 0 z.B. 10 angegeben, wuerden maximal
   //           10 Nachpunktstellen erzeugt)
   // flt       Diese spezielle GMP-float-Zahl wird in 2 Strings (exponent
   //           und mantisse) umgewandelt.

// printf("\n");
   // Wenn flt den Wert 0.0 hat ist mantisse ein leerer String, aber
   // wir geben "0.0" aus (nicht "0.")
   if (*mantisse == 0) {
      printf("%s 0.0\n", txt);            // flt hat den Wert 0.0
   } else {
      printf("%s 0.%s", txt, mantisse);
      // Der exponent wird nicht ausgegeben wenn er gleich 0 ist:
      if (exponent != 0) {
         printf(" mal 10^%d\n", exponent);
      } else {
         printf("\n");
      }
   } // if-else

// gibAusLineal(strlen(txt)+3, strlen(mantisse));
} // gibAusGmpFloat
// ------------------------------------------------------------------------

int main(int argc, char * args[]) {
   progName = args[0];
   printf("NachfolgerFloat: Jetzt geht es los!\n");
   printf("-----------------------------------------------------------\n");
   while (true) {
      float flt = liesFloat();
      int * iad = (int*) &flt;
      int   i;
      mpf_t mpf;                 // Eine gmp-float-Variable mpf
      mpf_init2(mpf, 200);       // Mit Genauigkeit 200 Bits initialisieren
      for (i=1; i<=10; i++) {
         mpf_set_d(mpf, flt);    // Einen float-Wert an flt zuweisen
         printf("flt: %60.50f\n", flt);
         gibAusGmpFloat(mpf);

         (*iad)++;
      }
   } // while

   printf("-----------------------------------------------------------\n");
   printf("NachfolgerFloat: Das war's erstmal!\n");
   return 0;
} // main
