// Datei printf02.c
/* ------------------------------------------------------------------------
Formatierte Ausgabe in einen String (mit sprintf).
------------------------------------------------------------------------ */
#include <stdio.h>   // E/A in Bytestroeme, printf, sprintf, ...
#include <string.h>  // memcopy, memmove, strcpy, strcat, ...

// Weil einige C-Ausfuehrer stdbool.h und true immer noch nicht kennen
// (z.B. cl von Microsoft und icl von Intel):
#define true 1

int main() {
   // ---------------------------------------------------------------------
   unsigned mindestBreite = 10;
   unsigned genauigkeit   =  2;

   // Im Formatstring fsA fehlen noch 2 Ganzzahlen (die Mindestbreite
   // und die Genauigkeit des Formats). Die werden zur Laufzeit ein-
   // gelesen und eingefuegt (mit sprintf):
   char * fsA = "->%%%u.%uf<-"; // Ein unvollstaendiges Format
   char   fsB[100];             // Hier kommt das vollstaendige rein
   char   einZeichen;           // Fuer das q zum Beenden

   double dR[] = {     +1.5, +12.345,              +0.0,
                    +1.0E+7, +1.0E-7, +12345.6789012345,
                       -1.5, -12.345,              -0.0,
                    -1.0E+7, -1.0E-7, -12345.6789012345,
                 };
   int i;                       // Fuer for-Schleifen
   // ---------------------------------------------------------------------
   printf("printf02: Jetzt geht es los!\n");

   while (true) {
       printf("Mindestbreite und Genauigkeit (oder q zum Beenden): ");

      // Soll das Programm beendet werden?
      einZeichen = getc(stdin);     // 1 Zeichen aus dem Puffer holen
      if (einZeichen == 'q') {
         break;
      } else {
         ungetc(einZeichen, stdin); // 1 Zeichen in den Puffer zuruecklegen
      } // if

      // Mindestbreite und Genauigkeit vo der Standardeingabe einlesen:
      scanf  ("%u %u", &mindestBreite, &genauigkeit);
      getchar();
      // Einen Formatstring mit Mindestbreite und Genauigkeit erzeugen
      // und in den String fsB "ausgeben":
      sprintf(fsB, fsA, mindestBreite, genauigkeit);

      // Den vollstaendigen Formatstring fsB ausgeben und anwenden:
      for (i=0; i<sizeof(dR)/sizeof(dR[0]); i++) {
         double d = dR[i];
         printf ("printf(\"%s\", %20.10f); \"", fsB, d);
         printf (fsB, d);
         printf("\n");
      }
   } // while (true)

   printf("printf02: Das war's erstmal!\n");
   return 0;
   // ---------------------------------------------------------------------
} // main
